#include <bits/stdc++.h>
using namespace std;

int LIS(const vector<int> &A) {
    // inicializujeme si C tak, aby C[0]=-inf; v každom okamihu si budeme pamätať len tú časť C ktorá je < inf.
    vector<int> C(1, -(1<<30));
    for (int a : A) {
        // nájdeme najmenšie i také, že C[i] >= a
        unsigned i = upper_bound( C.begin(), C.end(), a-1 ) - C.begin();
        // upravíme hodnotu C[i] na a
        if (i == C.size()) C.push_back(a); else C[i] = a;
    }
    return C.size()-1;
}

int main() {
    int N;
    cin >> N;
    vector<int> F(N);
    for (int n=0; n<N; ++n) cin >> F[n];

    int odpoved = 0;

    for (int z=0; z<N; ++z) {
        vector<int> vacsie, mensie;
        for (int i=z+1; i<N; ++i) {
            if (F[i] > F[z]) vacsie.push_back(F[i]);
            else mensie.push_back(-F[i]);
        }
        odpoved = max( odpoved, 1 + LIS(vacsie) + LIS(mensie) );
    }
    cout << odpoved << endl;
}
