#include <bits/stdc++.h>
using namespace std;

vector<int> LIS(const vector<int> &A) {
    // pre každý prvok A vrátime dĺžku najdlhšej rastúcej postupnosti, ktorá ním končí
    vector<int> odpoved;
    vector<int> konce(1,-(1<<30));
    for (int a : A) {
        auto kam = upper_bound( konce.begin(), konce.end(), a );
        odpoved.push_back( kam - konce.begin() );
        if (kam == konce.end()) konce.push_back(a); else *kam = a;
    }
    return odpoved;
}

int main() {
    int N;
    cin >> N;
    vector<int> F(N);
    for (int n=0; n<N; ++n) cin >> F[n];
    reverse( F.begin(), F.end() );

    vector<int> lis(N,1), lds(N,1);
    for (int n=1; n<N; ++n) {
        for (int p=0; p<n; ++p) {
            if (F[n] < F[p]) {
                lds[n] = max( lds[n], 1+lds[p] );
            } else {
                lis[n] = max( lis[n], 1+lis[p] );
            }
        }
    }
    int odpoved = 0;
    for (int n=0; n<N; ++n) odpoved = max( odpoved, lis[n]+lds[n]-1 );
    cout << odpoved << endl;
}
