#include <bits/stdc++.h>
using namespace std;

int LIS(const vector<int> &seq) {
    int N = seq.size();
    if (N == 0) return 0;
    vector<int> best(N,1);
    for (int n=1; n<N; ++n) {
        for (int p=0; p<n; ++p) {
            if (seq[p] < seq[n]) {
                best[n] = max( best[n], 1+best[p] );
            }
        }
    }
    return *max_element(best.begin(),best.end());
}

int main() {
    int N;
    cin >> N;
    vector<int> F(N);
    for (int n=0; n<N; ++n) cin >> F[n];

    int odpoved = 0;

    for (int z=0; z<N; ++z) {
        vector<int> vacsie, mensie;
        for (int i=z+1; i<N; ++i) {
            if (F[i] > F[z]) vacsie.push_back(F[i]);
            else mensie.push_back(-F[i]);
        }
        odpoved = max( odpoved, 1 + LIS(vacsie) + LIS(mensie) );
    }
    cout << odpoved << endl;
}
